Package com.google.protobuf

## Class Descriptors.EnumDescriptor

- java.lang.Object
- - com.google.protobuf.Descriptors.GenericDescriptor
  - - com.google.protobuf.Descriptors.EnumDescriptor

All Implemented Interfaces:
  `Internal.EnumLiteMap<Descriptors.EnumValueDescriptor>`

Enclosing class:
  Descriptors

    public static final class Descriptors.EnumDescriptor
    extends Descriptors.GenericDescriptor
    implements Internal.EnumLiteMap<Descriptors.EnumValueDescriptor>

Describes an enum type.

### Method Summary

All Methods Instance Methods Concrete Methods
`Descriptors.EnumValueDescriptor` `findValueByName​(java.lang.String name)` Find an enum value by name.
`Descriptors.EnumValueDescriptor` `findValueByNumber​(int number)` Find an enum value by number.
`Descriptors.Descriptor` `getContainingType()` If this is a nested type, get the outer descriptor, otherwise null.
`Descriptors.FileDescriptor` `getFile()` Get the `Descriptors.FileDescriptor` containing this descriptor.
`java.lang.String` `getFullName()` Get the type's fully-qualified name.
`int` `getIndex()` Get the index of this descriptor within its parent.
`java.lang.String` `getName()` Get the type's unqualified name.
`DescriptorProtos.EnumOptions` `getOptions()` Get the `EnumOptions`, defined in `descriptor.proto`.
`java.util.List<Descriptors.EnumValueDescriptor>` `getValues()` Get a list of defined values for this enum.
`DescriptorProtos.EnumDescriptorProto` `toProto()` Convert the descriptor to its protocol message representation.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### getIndex

    public int getIndex()

Get the index of this descriptor within its parent.

See Also:
  `Descriptors.Descriptor.getIndex()`

#### toProto

    public DescriptorProtos.EnumDescriptorProto toProto()

Convert the descriptor to its protocol message representation.

Specified by:
  `toProto` in class `Descriptors.GenericDescriptor`

#### getName

    public java.lang.String getName()

Get the type's unqualified name.

Specified by:
  `getName` in class `Descriptors.GenericDescriptor`

#### getFullName

    public java.lang.String getFullName()

Get the type's fully-qualified name.

Specified by:
  `getFullName` in class `Descriptors.GenericDescriptor`
See Also:
  `Descriptors.Descriptor.getFullName()`

#### getFile

    public Descriptors.FileDescriptor getFile()

Get the `Descriptors.FileDescriptor` containing this descriptor.

Specified by:
  `getFile` in class `Descriptors.GenericDescriptor`

#### getContainingType

    public Descriptors.Descriptor getContainingType()

If this is a nested type, get the outer descriptor, otherwise null.

#### getOptions

    public DescriptorProtos.EnumOptions getOptions()

Get the `EnumOptions`, defined in `descriptor.proto`.

#### getValues

    public java.util.List<Descriptors.EnumValueDescriptor> getValues()

Get a list of defined values for this enum.

#### findValueByName

    public Descriptors.EnumValueDescriptor findValueByName​(java.lang.String name)

Find an enum value by name.

Parameters:
  `name` - The unqualified name of the value (e.g. "FOO").
Returns:
  the value's descriptor, or `null` if not found.

#### findValueByNumber

    public Descriptors.EnumValueDescriptor findValueByNumber​(int number)

Find an enum value by number. If multiple enum values have the same number, this returns the first defined value with that number.

Specified by:
  `findValueByNumber` in interface `Internal.EnumLiteMap<Descriptors.EnumValueDescriptor>`
Parameters:
  `number` - The value's number.
Returns:
  the value's descriptor, or `null` if not found.